include("StationHelper");

-- STATION POPUP
-- This popup occurs when a player clicks on a station
PopupLayouts[ButtonPopupTypes.BUTTONPOPUP_STATION] = function(popupInfo)

	local plotIndex = popupInfo.Data1;
	local station = Game.GetStationByPlot(plotIndex);

	if (station ~= nil) then
		
		-- Initialize popup text	
		local titleText = Locale.ConvertTextKey("TXT_KEY_POPUP_VIEW_STATION")
		local messageText = station:GetMessageString(Game.GetActivePlayer());
		local levelText = station:GetLevelString(Game.GetActivePlayer());

		-- XXX Mod changes to get the station flavor text.
		-- There doesn't seem to be an interface like station:GetQuestPromptKey() to make this easy
		-- so it's aparently necessary to query the general database.
		local myQuery = "select QuestPromptKey from stations where ID = ?"
		local myStationID = station:GetType() -- station:GetType() actually returns the 'ID' rather than the 'type'
		local myQuestPromptKey = ""
		local myStationFlavorText = ""

		for entry in DB.Query(myQuery, myStationID) do myQuestPromptKey = entry.QuestPromptKey; end
		myStationFlavorText = Locale.ConvertTextKey(myQuestPromptKey);
		if(string.len(myStationFlavorText) > 0) then 
			myStationFlavorText = myStationFlavorText .. "[NEWLINE][NEWLINE]"; 
		end
		-- END mod changes

		-- Populate text
		-- XXX mod change to add the text to the popup
		local popupText = titleText .. "[NEWLINE][NEWLINE]" .. myStationFlavorText .. messageText .. "[NEWLINE][NEWLINE]" .. levelText;
		-- END mod change original line below:
		-- local popupText = titleText .. "[NEWLINE][NEWLINE]" .. messageText .. "[NEWLINE][NEWLINE]" .. levelText;
		SetPopupText(popupText);
	end

	Controls.CloseButton:SetHide( false );
end

----------------------------------------------------------------        
-- Key Down Processing
----------------------------------------------------------------        
PopupInputHandlers[ButtonPopupTypes.BUTTONPOPUP_STATION] = function( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then
        if( wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN ) then
			HideWindow();
            return true;
        end
    end
end

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
Events.GameplaySetActivePlayer.Add(HideWindow);
